<?php // $Id$

/**
 * List creation and editing form.
 */
function mlm_form($form_state, $mlm = NULL) {
  if (!$mlm) {
    if (count($backends = mlm_backend_names()) == 1) {
      $mlm = mlm_load(key($backends));
    }
    elseif (isset($form_state['storage']['set_mlm_list'])) {
      $mlm = mlm_load($form_state['storage']['set_mlm_list']);
    }
    else {
      // List type selection form.
      $form['set_mlm_list'] = array(
        '#type' => 'select',
        '#title' => t('Mailing list backend'),
        '#options' => $backends,
      );
      $form['submit'] = array(
        '#type' => 'submit',
        '#value' => t('Next'),
      );
    }
  }
  if ($mlm) {
    $form = $mlm->_edit_form($form_state);

    $title = $mlm->lid ? $mlm->title() : t('Add a list');
    drupal_set_title($title);

    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Submit'),
    );
  }

  return $form;
}

/**
 * Validation handler for list creation.
 */
function mlm_form_validate($form, &$form_state) {
  if (isset($form_state['values']['backend'])) {
    $mlm = mlm_load($form_state['values']);
    $mlm->_edit_form_validate($form, $form_state, $form_state['values']);
  }
}

/**
 * Submit handler for list creation.
 */
function mlm_form_submit($form, &$form_state) {
  if ($form_state['values']['set_mlm_list']) {
    if (!count($form_state['storage'])) {
      $form_state['storage'] = $form_state['values'];
      $form_state['rebuild'] = TRUE;
    }
    return;
  }
  if (isset($form_state['values']['backend'])) {
    $mlm = mlm_load($form_state['values']);
    $mlm->_edit_form_submit($form, $form_state, $form_state['values']);
    $mlm->_save();
    unset($form_state['rebuild'], $form_state['storage']);
    $form_state['redirect'] = $mlm->path();
  }
}

/**
 * Menu callback -- ask for confirmation of list deletion
 */
function mlm_delete_confirm(&$form_state, $mlm) {
  $form['mlm'] = array(
    '#type' => 'value',
    '#value' => $mlm->lid,
  );

  return confirm_form($form,
    t('Are you sure you want to delete %title?', array('%title' => $mlm->title())),
    isset($_GET['destination']) ? $_GET['destination'] : 'mlm/'. $mlm->lid,
    t('This action cannot be undone.'),
    t('Delete'),
    t('Cancel')
  );
}

/**
 * Execute node deletion
 */
function mlm_delete_confirm_submit($form, &$form_state) {
  if ($form_state['values']['confirm']) {
    $mlm = mlm_load($form_state['values']['mlm']);
    $mlm->_delete();
  }

  $form_state['redirect'] = '<front>';
}
